import{S as Ki,i as Qi,s as Xi,e as r,k as u,w as oi,t as a,M as Yi,c as o,d as t,m as f,a as n,x as ai,h as s,b as c,N as et,G as i,g as h,y as si,L as Zi,q as ni,o as li,B as hi,v as er}from"../../chunks/vendor-hf-doc-builder.js";import{I as ci}from"../../chunks/IconCopyLink-hf-doc-builder.js";function tr(ui){let g,_e,v,b,X,A,tt,Y,it,be,F,rt,Ee,E,Z,G,ot,at,ee,M,st,Te,y,T,te,O,nt,ie,lt,xe,B,ht,Ce,d,ct,re,ut,ft,oe,pt,dt,ke,m,mt,ae,wt,gt,se,vt,yt,Re,x,U,fi,_t,ne,bt,Pe,p,Et,I,Tt,xt,le,Ct,kt,he,Rt,Pt,Se,D,pi,$e,C,St,ce,$t,Nt,Ne,_,k,ue,j,Lt,fe,At,Le,R,Gt,pe,Mt,Ot,Ae,z,de,It,Dt,Ge,P,jt,me,zt,qt,Me,S,Ht,we,Wt,Ft,Oe,q,di,Ie,$,Bt,ge,Ut,Vt,De,V,Jt,je,H,mi,ze,N,Kt,ve,Qt,Xt,qe,w,Yt,ye,Zt,ei,W,ti,ii,He;return A=new ci({}),O=new ci({}),j=new ci({}),{c(){g=r("meta"),_e=u(),v=r("h1"),b=r("a"),X=r("span"),oi(A.$$.fragment),tt=u(),Y=r("span"),it=a("(Optional) What is Curiosity in Deep Reinforcement Learning?"),be=u(),F=r("p"),rt=a("This is an (optional) introduction to Curiosity. If you want to learn more, you can read two additional articles where we dive into the mathematical details:"),Ee=u(),E=r("ul"),Z=r("li"),G=r("a"),ot=a("Curiosity-Driven Learning through Next State Prediction"),at=u(),ee=r("li"),M=r("a"),st=a("Random Network Distillation: a new take on Curiosity-Driven Learning"),Te=u(),y=r("h2"),T=r("a"),te=r("span"),oi(O.$$.fragment),nt=u(),ie=r("span"),lt=a("Two Major Problems in Modern RL"),xe=u(),B=r("p"),ht=a("To understand what Curiosity is, we first need to understand the two major problems with RL:"),Ce=u(),d=r("p"),ct=a("First, the "),re=r("em"),ut=a("sparse rewards problem:"),ft=a(" that is, "),oe=r("strong"),pt=a("most rewards do not contain information, and hence are set to zero"),dt=a("."),ke=u(),m=r("p"),mt=a("Remember that RL is based on the "),ae=r("em"),wt=a("reward hypothesis"),gt=a(", which is the idea that each goal can be described as the maximization of the rewards. Therefore, rewards act as feedback for RL agents; "),se=r("strong"),vt=a("if they don\u2019t receive any, their knowledge of which action is appropriate (or not) cannot change"),yt=a("."),Re=u(),x=r("figure"),U=r("img"),_t=u(),ne=r("figcaption"),bt=a("Source: Thanks to the reward, our agent knows that this action at that state was good"),Pe=u(),p=r("p"),Et=a("For instance, in "),I=r("a"),Tt=a("Vizdoom"),xt=a(", a set of environments based on the game Doom \u201CDoomMyWayHome,\u201D your agent is only rewarded "),le=r("strong"),Ct=a("if it finds the vest"),kt=a(`.
However, the vest is far away from your starting point, so most of your rewards will be zero. Therefore, if our agent does not receive useful feedback (dense rewards), it will take much longer to learn an optimal policy, and `),he=r("strong"),Rt=a("it can spend time turning around without finding the goal"),Pt=a("."),Se=u(),D=r("img"),$e=u(),C=r("p"),St=a("The second big problem is that "),ce=r("strong"),$t=a("the extrinsic reward function is handmade; in each environment, a human has to implement a reward function"),Nt=a(". But how we can scale that in big and complex environments?"),Ne=u(),_=r("h2"),k=r("a"),ue=r("span"),oi(j.$$.fragment),Lt=u(),fe=r("span"),At=a("So what is Curiosity?"),Le=u(),R=r("p"),Gt=a("A solution to these problems is "),pe=r("strong"),Mt=a("to develop a reward function intrinsic to the agent, i.e., generated by the agent itself"),Ot=a(". The agent will act as a self-learner since it will be the student and its own feedback master."),Ae=u(),z=r("p"),de=r("strong"),It=a("This intrinsic reward mechanism is known as Curiosity"),Dt=a(" because this reward pushes the agent to explore states that are novel/unfamiliar. To achieve that, our agent will receive a high reward when exploring new trajectories."),Ge=u(),P=r("p"),jt=a("This reward is inspired by how humans act. "),me=r("strong"),zt=a("We naturally have an intrinsic desire to explore environments and discover new things"),qt=a("."),Me=u(),S=r("p"),Ht=a("There are different ways to calculate this intrinsic reward. The classical approach (Curiosity through next-state prediction) is to calculate Curiosity "),we=r("strong"),Wt=a("as the error of our agent in predicting the next state, given the current state and action taken"),Ft=a("."),Oe=u(),q=r("img"),Ie=u(),$=r("p"),Bt=a("Because the idea of Curiosity is to "),ge=r("strong"),Ut=a("encourage our agent to perform actions that reduce the uncertainty in the agent\u2019s ability to predict the consequences of its actions"),Vt=a(" (uncertainty will be higher in areas where the agent has spent less time or in areas with complex dynamics)."),De=u(),V=r("p"),Jt=a("If the agent spends a lot of time on these states, it will be good at predicting the next state (low Curiosity). On the other hand, if it\u2019s in a new, unexplored state, it will be hard to predict the following state (high Curiosity)."),je=u(),H=r("img"),ze=u(),N=r("p"),Kt=a("Using Curiosity will push our agent to favor transitions with high prediction error (which will be higher in areas where the agent has spent less time, or in areas with complex dynamics) and "),ve=r("strong"),Qt=a("consequently better explore our environment"),Xt=a("."),qe=u(),w=r("p"),Yt=a("There\u2019s also "),ye=r("strong"),Zt=a("other curiosity calculation methods"),ei=a(". ML-Agents uses a more advanced one called Curiosity through random network distillation. This is out of the scope of the tutorial but if you\u2019re interested "),W=r("a"),ti=a("I wrote an article explaining it in detail"),ii=a("."),this.h()},l(e){const l=Yi('[data-svelte="svelte-1phssyn"]',document.head);g=o(l,"META",{name:!0,content:!0}),l.forEach(t),_e=f(e),v=o(e,"H1",{class:!0});var We=n(v);b=o(We,"A",{id:!0,class:!0,href:!0});var wi=n(b);X=o(wi,"SPAN",{});var gi=n(X);ai(A.$$.fragment,gi),gi.forEach(t),wi.forEach(t),tt=f(We),Y=o(We,"SPAN",{});var vi=n(Y);it=s(vi,"(Optional) What is Curiosity in Deep Reinforcement Learning?"),vi.forEach(t),We.forEach(t),be=f(e),F=o(e,"P",{});var yi=n(F);rt=s(yi,"This is an (optional) introduction to Curiosity. If you want to learn more, you can read two additional articles where we dive into the mathematical details:"),yi.forEach(t),Ee=f(e),E=o(e,"UL",{});var Fe=n(E);Z=o(Fe,"LI",{});var _i=n(Z);G=o(_i,"A",{href:!0,rel:!0});var bi=n(G);ot=s(bi,"Curiosity-Driven Learning through Next State Prediction"),bi.forEach(t),_i.forEach(t),at=f(Fe),ee=o(Fe,"LI",{});var Ei=n(ee);M=o(Ei,"A",{href:!0,rel:!0});var Ti=n(M);st=s(Ti,"Random Network Distillation: a new take on Curiosity-Driven Learning"),Ti.forEach(t),Ei.forEach(t),Fe.forEach(t),Te=f(e),y=o(e,"H2",{class:!0});var Be=n(y);T=o(Be,"A",{id:!0,class:!0,href:!0});var xi=n(T);te=o(xi,"SPAN",{});var Ci=n(te);ai(O.$$.fragment,Ci),Ci.forEach(t),xi.forEach(t),nt=f(Be),ie=o(Be,"SPAN",{});var ki=n(ie);lt=s(ki,"Two Major Problems in Modern RL"),ki.forEach(t),Be.forEach(t),xe=f(e),B=o(e,"P",{});var Ri=n(B);ht=s(Ri,"To understand what Curiosity is, we first need to understand the two major problems with RL:"),Ri.forEach(t),Ce=f(e),d=o(e,"P",{});var J=n(d);ct=s(J,"First, the "),re=o(J,"EM",{});var Pi=n(re);ut=s(Pi,"sparse rewards problem:"),Pi.forEach(t),ft=s(J," that is, "),oe=o(J,"STRONG",{});var Si=n(oe);pt=s(Si,"most rewards do not contain information, and hence are set to zero"),Si.forEach(t),dt=s(J,"."),J.forEach(t),ke=f(e),m=o(e,"P",{});var K=n(m);mt=s(K,"Remember that RL is based on the "),ae=o(K,"EM",{});var $i=n(ae);wt=s($i,"reward hypothesis"),$i.forEach(t),gt=s(K,", which is the idea that each goal can be described as the maximization of the rewards. Therefore, rewards act as feedback for RL agents; "),se=o(K,"STRONG",{});var Ni=n(se);vt=s(Ni,"if they don\u2019t receive any, their knowledge of which action is appropriate (or not) cannot change"),Ni.forEach(t),yt=s(K,"."),K.forEach(t),Re=f(e),x=o(e,"FIGURE",{});var Ue=n(x);U=o(Ue,"IMG",{src:!0,alt:!0}),_t=f(Ue),ne=o(Ue,"FIGCAPTION",{});var Li=n(ne);bt=s(Li,"Source: Thanks to the reward, our agent knows that this action at that state was good"),Li.forEach(t),Ue.forEach(t),Pe=f(e),p=o(e,"P",{});var L=n(p);Et=s(L,"For instance, in "),I=o(L,"A",{href:!0,rel:!0});var Ai=n(I);Tt=s(Ai,"Vizdoom"),Ai.forEach(t),xt=s(L,", a set of environments based on the game Doom \u201CDoomMyWayHome,\u201D your agent is only rewarded "),le=o(L,"STRONG",{});var Gi=n(le);Ct=s(Gi,"if it finds the vest"),Gi.forEach(t),kt=s(L,`.
However, the vest is far away from your starting point, so most of your rewards will be zero. Therefore, if our agent does not receive useful feedback (dense rewards), it will take much longer to learn an optimal policy, and `),he=o(L,"STRONG",{});var Mi=n(he);Rt=s(Mi,"it can spend time turning around without finding the goal"),Mi.forEach(t),Pt=s(L,"."),L.forEach(t),Se=f(e),D=o(e,"IMG",{src:!0,alt:!0}),$e=f(e),C=o(e,"P",{});var Ve=n(C);St=s(Ve,"The second big problem is that "),ce=o(Ve,"STRONG",{});var Oi=n(ce);$t=s(Oi,"the extrinsic reward function is handmade; in each environment, a human has to implement a reward function"),Oi.forEach(t),Nt=s(Ve,". But how we can scale that in big and complex environments?"),Ve.forEach(t),Ne=f(e),_=o(e,"H2",{class:!0});var Je=n(_);k=o(Je,"A",{id:!0,class:!0,href:!0});var Ii=n(k);ue=o(Ii,"SPAN",{});var Di=n(ue);ai(j.$$.fragment,Di),Di.forEach(t),Ii.forEach(t),Lt=f(Je),fe=o(Je,"SPAN",{});var ji=n(fe);At=s(ji,"So what is Curiosity?"),ji.forEach(t),Je.forEach(t),Le=f(e),R=o(e,"P",{});var Ke=n(R);Gt=s(Ke,"A solution to these problems is "),pe=o(Ke,"STRONG",{});var zi=n(pe);Mt=s(zi,"to develop a reward function intrinsic to the agent, i.e., generated by the agent itself"),zi.forEach(t),Ot=s(Ke,". The agent will act as a self-learner since it will be the student and its own feedback master."),Ke.forEach(t),Ae=f(e),z=o(e,"P",{});var ri=n(z);de=o(ri,"STRONG",{});var qi=n(de);It=s(qi,"This intrinsic reward mechanism is known as Curiosity"),qi.forEach(t),Dt=s(ri," because this reward pushes the agent to explore states that are novel/unfamiliar. To achieve that, our agent will receive a high reward when exploring new trajectories."),ri.forEach(t),Ge=f(e),P=o(e,"P",{});var Qe=n(P);jt=s(Qe,"This reward is inspired by how humans act. "),me=o(Qe,"STRONG",{});var Hi=n(me);zt=s(Hi,"We naturally have an intrinsic desire to explore environments and discover new things"),Hi.forEach(t),qt=s(Qe,"."),Qe.forEach(t),Me=f(e),S=o(e,"P",{});var Xe=n(S);Ht=s(Xe,"There are different ways to calculate this intrinsic reward. The classical approach (Curiosity through next-state prediction) is to calculate Curiosity "),we=o(Xe,"STRONG",{});var Wi=n(we);Wt=s(Wi,"as the error of our agent in predicting the next state, given the current state and action taken"),Wi.forEach(t),Ft=s(Xe,"."),Xe.forEach(t),Oe=f(e),q=o(e,"IMG",{src:!0,alt:!0}),Ie=f(e),$=o(e,"P",{});var Ye=n($);Bt=s(Ye,"Because the idea of Curiosity is to "),ge=o(Ye,"STRONG",{});var Fi=n(ge);Ut=s(Fi,"encourage our agent to perform actions that reduce the uncertainty in the agent\u2019s ability to predict the consequences of its actions"),Fi.forEach(t),Vt=s(Ye," (uncertainty will be higher in areas where the agent has spent less time or in areas with complex dynamics)."),Ye.forEach(t),De=f(e),V=o(e,"P",{});var Bi=n(V);Jt=s(Bi,"If the agent spends a lot of time on these states, it will be good at predicting the next state (low Curiosity). On the other hand, if it\u2019s in a new, unexplored state, it will be hard to predict the following state (high Curiosity)."),Bi.forEach(t),je=f(e),H=o(e,"IMG",{src:!0,alt:!0}),ze=f(e),N=o(e,"P",{});var Ze=n(N);Kt=s(Ze,"Using Curiosity will push our agent to favor transitions with high prediction error (which will be higher in areas where the agent has spent less time, or in areas with complex dynamics) and "),ve=o(Ze,"STRONG",{});var Ui=n(ve);Qt=s(Ui,"consequently better explore our environment"),Ui.forEach(t),Xt=s(Ze,"."),Ze.forEach(t),qe=f(e),w=o(e,"P",{});var Q=n(w);Yt=s(Q,"There\u2019s also "),ye=o(Q,"STRONG",{});var Vi=n(ye);Zt=s(Vi,"other curiosity calculation methods"),Vi.forEach(t),ei=s(Q,". ML-Agents uses a more advanced one called Curiosity through random network distillation. This is out of the scope of the tutorial but if you\u2019re interested "),W=o(Q,"A",{href:!0,rel:!0});var Ji=n(W);ti=s(Ji,"I wrote an article explaining it in detail"),Ji.forEach(t),ii=s(Q,"."),Q.forEach(t),this.h()},h(){c(g,"name","hf:doc:metadata"),c(g,"content",JSON.stringify(ir)),c(b,"id","optional-what-is-curiosity-in-deep-reinforcement-learning"),c(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(b,"href","#optional-what-is-curiosity-in-deep-reinforcement-learning"),c(v,"class","relative group"),c(G,"href","https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-next-state-prediction-f7f4e2f592fa"),c(G,"rel","nofollow"),c(M,"href","https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-random-network-distillation-488ffd8e5938"),c(M,"rel","nofollow"),c(T,"id","two-major-problems-in-modern-rl"),c(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(T,"href","#two-major-problems-in-modern-rl"),c(y,"class","relative group"),et(U.src,fi="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity1.png")||c(U,"src",fi),c(U,"alt","Curiosity"),c(I,"href","https://vizdoom.cs.put.edu.pl/"),c(I,"rel","nofollow"),et(D.src,pi="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity2.png")||c(D,"src",pi),c(D,"alt","Curiosity"),c(k,"id","so-what-is-curiosity"),c(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(k,"href","#so-what-is-curiosity"),c(_,"class","relative group"),et(q.src,di="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity3.png")||c(q,"src",di),c(q,"alt","Curiosity"),et(H.src,mi="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/curiosity4.png")||c(H,"src",mi),c(H,"alt","Curiosity"),c(W,"href","https://medium.com/data-from-the-trenches/curiosity-driven-learning-through-random-network-distillation-488ffd8e5938"),c(W,"rel","nofollow")},m(e,l){i(document.head,g),h(e,_e,l),h(e,v,l),i(v,b),i(b,X),si(A,X,null),i(v,tt),i(v,Y),i(Y,it),h(e,be,l),h(e,F,l),i(F,rt),h(e,Ee,l),h(e,E,l),i(E,Z),i(Z,G),i(G,ot),i(E,at),i(E,ee),i(ee,M),i(M,st),h(e,Te,l),h(e,y,l),i(y,T),i(T,te),si(O,te,null),i(y,nt),i(y,ie),i(ie,lt),h(e,xe,l),h(e,B,l),i(B,ht),h(e,Ce,l),h(e,d,l),i(d,ct),i(d,re),i(re,ut),i(d,ft),i(d,oe),i(oe,pt),i(d,dt),h(e,ke,l),h(e,m,l),i(m,mt),i(m,ae),i(ae,wt),i(m,gt),i(m,se),i(se,vt),i(m,yt),h(e,Re,l),h(e,x,l),i(x,U),i(x,_t),i(x,ne),i(ne,bt),h(e,Pe,l),h(e,p,l),i(p,Et),i(p,I),i(I,Tt),i(p,xt),i(p,le),i(le,Ct),i(p,kt),i(p,he),i(he,Rt),i(p,Pt),h(e,Se,l),h(e,D,l),h(e,$e,l),h(e,C,l),i(C,St),i(C,ce),i(ce,$t),i(C,Nt),h(e,Ne,l),h(e,_,l),i(_,k),i(k,ue),si(j,ue,null),i(_,Lt),i(_,fe),i(fe,At),h(e,Le,l),h(e,R,l),i(R,Gt),i(R,pe),i(pe,Mt),i(R,Ot),h(e,Ae,l),h(e,z,l),i(z,de),i(de,It),i(z,Dt),h(e,Ge,l),h(e,P,l),i(P,jt),i(P,me),i(me,zt),i(P,qt),h(e,Me,l),h(e,S,l),i(S,Ht),i(S,we),i(we,Wt),i(S,Ft),h(e,Oe,l),h(e,q,l),h(e,Ie,l),h(e,$,l),i($,Bt),i($,ge),i(ge,Ut),i($,Vt),h(e,De,l),h(e,V,l),i(V,Jt),h(e,je,l),h(e,H,l),h(e,ze,l),h(e,N,l),i(N,Kt),i(N,ve),i(ve,Qt),i(N,Xt),h(e,qe,l),h(e,w,l),i(w,Yt),i(w,ye),i(ye,Zt),i(w,ei),i(w,W),i(W,ti),i(w,ii),He=!0},p:Zi,i(e){He||(ni(A.$$.fragment,e),ni(O.$$.fragment,e),ni(j.$$.fragment,e),He=!0)},o(e){li(A.$$.fragment,e),li(O.$$.fragment,e),li(j.$$.fragment,e),He=!1},d(e){t(g),e&&t(_e),e&&t(v),hi(A),e&&t(be),e&&t(F),e&&t(Ee),e&&t(E),e&&t(Te),e&&t(y),hi(O),e&&t(xe),e&&t(B),e&&t(Ce),e&&t(d),e&&t(ke),e&&t(m),e&&t(Re),e&&t(x),e&&t(Pe),e&&t(p),e&&t(Se),e&&t(D),e&&t($e),e&&t(C),e&&t(Ne),e&&t(_),hi(j),e&&t(Le),e&&t(R),e&&t(Ae),e&&t(z),e&&t(Ge),e&&t(P),e&&t(Me),e&&t(S),e&&t(Oe),e&&t(q),e&&t(Ie),e&&t($),e&&t(De),e&&t(V),e&&t(je),e&&t(H),e&&t(ze),e&&t(N),e&&t(qe),e&&t(w)}}}const ir={local:"optional-what-is-curiosity-in-deep-reinforcement-learning",sections:[{local:"two-major-problems-in-modern-rl",title:"Two Major Problems in Modern RL"},{local:"so-what-is-curiosity",title:"So what is Curiosity?"}],title:"(Optional) What is Curiosity in Deep Reinforcement Learning?"};function rr(ui){return er(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class sr extends Ki{constructor(g){super();Qi(this,g,rr,tr,Xi,{})}}export{sr as default,ir as metadata};
